module.exports = {
  env: {
    browser: true,
    node: true,
    es6: true,
    jest: true
  },
  parser: '@typescript-eslint/parser',
  plugins: ['prettier', '@typescript-eslint'],
  settings: {
    react: {
      version: 'detect'
    }
  },
  parserOptions: {
    project: './tsconfig.json',
    createDefaultProgram: true,
    ecmaVersion: 2018,
    sourceType: 'module'
  },
  extends: [
    'prettier',
    'eslint:recommended',
    'plugin:react/recommended',
    'plugin:import/recommended',
    'plugin:@typescript-eslint/recommended',
    'plugin:import/typescript',
    'plugin:react-hooks/recommended'
  ],
  rules: {
    'prettier/prettier': [
      'error',
      {
        printWidth: 80,
        tabWidth: 2,
        singleQuote: true,
        semi: true,
        trailingComma: 'none',
        bracketSpacing: true,
        endOfLine: 'lf',
        arrowParens: 'avoid'
      }
    ],
    // 无意义的constructor
    '@typescript-eslint/no-useless-constructor': 'error',
    // 要求类成员之间有空行
    '@typescript-eslint/lines-between-class-members': 'error',
    // 可以使用require
    '@typescript-eslint/no-var-requires': 0,
    '@typescript-eslint/ban-ts-comment': 0,
    '@typescript-eslint/no-explicit-any': 0,
    // 空函数
    '@typescript-eslint/no-empty-function': 0,
    'no-empty': 0,
    'no-irregular-whitespace': 0,
    'react/prop-types': 0,
    'react/no-unescaped-entities': 0,
    // 导入顺序
    'import/order': 'error',
    'no-console': 'error'
  }
};
